/*
 Highcharts JS v11.0.1 (2023-05-08)

 Timeline series

 (c) 2010-2021 Highsoft AS
 Author: Daniel Studencki

 License: www.highcharts.com/license
*/
'use strict';(function(a){"object"===typeof module&&module.exports?(a["default"]=a,module.exports=a):"function"===typeof define&&define.amd?define("highcharts/modules/timeline",["highcharts"],function(c){a(c);a.Highcharts=c;return a}):a("undefined"!==typeof Highcharts?Highcharts:void 0)})(function(a){function c(a,m,l,c){a.hasOwnProperty(m)||(a[m]=c.apply(null,l),"function"===typeof CustomEvent&&window.dispatchEvent(new CustomEvent("HighchartsModuleLoaded",{detail:{path:m,module:a[m]}})))}a=a?a._modules:
{};c(a,"Series/Timeline/TimelinePoint.js",[a["Core/Series/Point.js"],a["Core/Series/SeriesRegistry.js"],a["Core/Utilities.js"]],function(a,c,l){var m=this&&this.__extends||function(){var a=function(g,e){a=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,a){e.__proto__=a}||function(e,a){for(var h in a)Object.prototype.hasOwnProperty.call(a,h)&&(e[h]=a[h])};return a(g,e)};return function(g,e){function r(){this.constructor=g}if("function"!==typeof e&&null!==e)throw new TypeError("Class extends value "+
String(e)+" is not a constructor or null");a(g,e);g.prototype=null===e?Object.create(e):(r.prototype=e.prototype,new r)}}(),k=c.seriesTypes.pie.prototype.pointClass,w=l.defined,q=l.isNumber,u=l.merge,v=l.objectEach,n=l.pick;return function(c){function g(){var e=null!==c&&c.apply(this,arguments)||this;e.options=void 0;e.series=void 0;return e}m(g,c);g.prototype.alignConnector=function(){var e=this.series,a=this.connector,c=this.dataLabel,h=this.dataLabel.options=u(e.options.dataLabels,this.options.dataLabels),
d=this.series.chart,b=a.getBBox(),f=b.x+c.translateX;b=b.y+c.translateY;d.inverted?b-=c.options.connectorWidth/2:f+=c.options.connectorWidth/2;d=d.isInsidePlot(f,b);a[d?"animate":"attr"]({d:this.getConnectorPath()});a.addClass("highcharts-color-".concat(this.colorIndex));e.chart.styledMode||a.attr({stroke:h.connectorColor||this.color,"stroke-width":h.connectorWidth,opacity:c[w(c.newOpacity)?"newOpacity":"opacity"]})};g.prototype.drawConnector=function(){var a=this.series;this.connector||(this.connector=
a.chart.renderer.path(this.getConnectorPath()).attr({zIndex:-1}).add(this.dataLabel));this.series.chart.isInsidePlot(this.dataLabel.x,this.dataLabel.y)&&this.alignConnector()};g.prototype.getConnectorPath=function(){var a=this.series.chart,c=this.series.xAxis.len,g=a.inverted,h=g?"x2":"y2",d=this.dataLabel,b=d.targetPosition,f={x1:this.plotX,y1:this.plotY,x2:this.plotX,y2:q(b.y)?b.y:d.y},p=(d.alignAttr||d)[h[0]]<this.series.yAxis.len/2;g&&(f={x1:this.plotY,y1:c-this.plotX,x2:b.x||d.x,y2:c-this.plotX});
p&&(f[h]+=d[g?"width":"height"]);v(f,function(b,a){f[a]-=(d.alignAttr||d)[a[0]]});return a.renderer.crispLine([["M",f.x1,f.y1],["L",f.x2,f.y2]],d.options.connectorWidth)};g.prototype.init=function(){var a=c.prototype.init.apply(this,arguments);a.name=n(a.name,"Event");a.y=1;return a};g.prototype.isValid=function(){return null!==this.options.y};g.prototype.setState=function(){var a=c.prototype.setState;this.isNull||a.apply(this,arguments)};g.prototype.setVisible=function(a,c){var e=this.series;c=n(c,
e.options.ignoreHiddenPoint);k.prototype.setVisible.call(this,a,!1);e.processData();c&&e.chart.redraw()};g.prototype.applyOptions=function(e,g){e=a.prototype.optionsToObject.call(this,e);this.userDLOptions=u(this.userDLOptions,e.dataLabels);return c.prototype.applyOptions.call(this,e,g)};return g}(c.series.prototype.pointClass)});c(a,"Series/Timeline/TimelineSeriesDefaults.js",[],function(){"";return{colorByPoint:!0,stickyTracking:!1,ignoreHiddenPoint:!0,legendType:"point",lineWidth:4,tooltip:{headerFormat:'<span style="color:{point.color}">\u25cf</span> <span style="font-size: 0.8em"> {point.key}</span><br/>',
pointFormat:"{point.description}"},states:{hover:{lineWidthPlus:0}},dataLabels:{enabled:!0,allowOverlap:!0,alternate:!0,backgroundColor:"#ffffff",borderWidth:1,borderColor:"#999999",borderRadius:3,color:"#333333",connectorWidth:1,distance:100,formatter:function(){var a=this.series.chart.styledMode?'<span class="highcharts-color-'+this.point.colorIndex+'">\u25cf </span>':'<span style="color:'+this.point.color+'">\u25cf </span>';return a+='<span class="highcharts-strong">'+(this.key||"")+"</span><br/>"+
(this.point.label||"")},style:{textOutline:"none",fontWeight:"normal",fontSize:"0.8em"},shadow:!1,verticalAlign:"middle"},marker:{enabledThreshold:0,symbol:"square",radius:6,lineWidth:2,height:15},showInLegend:!1,colorKey:"x",legendSymbol:"rectangle"}});c(a,"Series/Timeline/TimelineSeries.js",[a["Core/Series/SeriesRegistry.js"],a["Core/Renderer/SVG/SVGElement.js"],a["Series/Timeline/TimelinePoint.js"],a["Series/Timeline/TimelineSeriesDefaults.js"],a["Core/Utilities.js"]],function(a,c,l,y,k){var m=
this&&this.__extends||function(){var a=function(c,b){a=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(b,a){b.__proto__=a}||function(b,a){for(var f in a)Object.prototype.hasOwnProperty.call(a,f)&&(b[f]=a[f])};return a(c,b)};return function(c,b){function f(){this.constructor=c}if("function"!==typeof b&&null!==b)throw new TypeError("Class extends value "+String(b)+" is not a constructor or null");a(c,b);c.prototype=null===b?Object.create(b):(f.prototype=b.prototype,new f)}}(),q=a.seriesTypes,
u=q.column,v=q.line,n=k.addEvent,w=k.arrayMax,g=k.arrayMin,e=k.defined;q=k.extend;var r=k.merge,x=k.pick;k=function(a){function d(){var b=null!==a&&a.apply(this,arguments)||this;b.data=void 0;b.options=void 0;b.points=void 0;b.userOptions=void 0;b.visibilityMap=void 0;return b}m(d,a);d.prototype.alignDataLabel=function(b,f,c,e){var d=this.chart.inverted,p=this.visibilityMap.filter(function(b){return b}),g=this.visiblePointsCount,t=p.indexOf(b);p=this.options.dataLabels;var k=b.userDLOptions||{};t=
p.alternate?t&&t!==g-1?2:1.5:1;g=Math.floor(this.xAxis.len/g);var h=f.padding;if(b.visible){var l=Math.abs(k.x||b.options.dataLabels.x);d?(d=2*(l-h)-b.itemHeight/2,d={width:d+"px",textOverflow:f.width/d*f.height/2>g*t?"ellipsis":"none"}):d={width:(k.width||p.width||g*t-2*h)+"px"};f.css(d);this.chart.styledMode||f.shadow(p.shadow)}a.prototype.alignDataLabel.apply(this,arguments)};d.prototype.bindAxes=function(){var b=this;a.prototype.bindAxes.call(b);["xAxis","yAxis"].forEach(function(a){"xAxis"!==
a||b[a].userOptions.type||(b[a].categories=b[a].hasNames=!0)})};d.prototype.distributeDL=function(){var b=this,a=b.options.dataLabels,c=1;if(a){var d=a.distance||0;b.points.forEach(function(f){var e;f.options.dataLabels=r((e={},e[b.chart.inverted?"x":"y"]=a.alternate&&c%2?-d:d,e),f.userDLOptions);c++})}};d.prototype.generatePoints=function(){var b=this;a.prototype.generatePoints.apply(b);b.points.forEach(function(a,c){a.applyOptions({x:b.xData[c]},b.xData[c])})};d.prototype.getVisibilityMap=function(){return(this.data.length?
this.data:this.userOptions.data).map(function(a){return a&&!1!==a.visible&&!a.isNull?a:!1})};d.prototype.getXExtremes=function(a){var b=this;a=a.filter(function(a,f){return b.points[f].isValid()&&b.points[f].visible});return{min:g(a),max:w(a)}};d.prototype.init=function(){var b=this;a.prototype.init.apply(b,arguments);b.eventsToUnbind.push(n(b,"afterTranslate",function(){var a,c=Number.MAX_VALUE;b.points.forEach(function(b){b.isInside=b.isInside&&b.visible;b.visible&&!b.isNull&&(e(a)&&(c=Math.min(c,
Math.abs(b.plotX-a))),a=b.plotX)});b.closestPointRangePx=c}));b.eventsToUnbind.push(n(b,"drawDataLabels",function(){b.distributeDL()}));b.eventsToUnbind.push(n(b,"afterDrawDataLabels",function(){var a;b.points.forEach(function(b){if(a=b.dataLabel)return a.animate=function(a){this.targetPosition&&(this.targetPosition=a);return c.prototype.animate.apply(this,arguments)},a.targetPosition||(a.targetPosition={}),b.drawConnector()})}));b.eventsToUnbind.push(n(b.chart,"afterHideOverlappingLabel",function(){b.points.forEach(function(a){a.connector&&
a.dataLabel&&a.dataLabel.oldOpacity!==a.dataLabel.newOpacity&&a.alignConnector()})}))};d.prototype.markerAttribs=function(b,c){var d=this.options.marker,f=b.marker||{},e=f.symbol||d.symbol,g=x(f.width,d.width,this.closestPointRangePx),k=x(f.height,d.height),h=0;if(this.xAxis.dateTime)return a.prototype.markerAttribs.call(this,b,c);c&&(d=d.states[c]||{},c=f.states&&f.states[c]||{},h=x(c.radius,d.radius,h+(d.radiusPlus||0)));b.hasImage=e&&0===e.indexOf("url");b={x:Math.floor(b.plotX)-g/2-h/2,y:b.plotY-
k/2-h/2,width:g+h,height:k+h};return this.chart.inverted?{y:b.x&&b.width&&this.xAxis.len-b.x-b.width,x:b.y&&b.y,width:b.height,height:b.width}:b};d.prototype.processData=function(){var b=0,c;this.visibilityMap=this.getVisibilityMap();this.visibilityMap.forEach(function(a){a&&b++});this.visiblePointsCount=b;for(c=0;c<this.xData.length;c++)this.yData[c]=1;a.prototype.processData.call(this,arguments)};d.defaultOptions=r(v.defaultOptions,y);return d}(v);q(k.prototype,{drawTracker:u.prototype.drawTracker,
pointClass:l,trackerGroups:["markerGroup","dataLabelsGroup"]});a.registerSeriesType("timeline",k);"";return k});c(a,"masters/modules/timeline.src.js",[],function(){})});
//# sourceMappingURL=timeline.js.map