/*
 Highcharts JS v11.0.1 (2023-05-08)

 X-range series

 (c) 2010-2021 Torstein Honsi, Lars A. V. Cabrera

 License: www.highcharts.com/license
*/
'use strict';(function(a){"object"===typeof module&&module.exports?(a["default"]=a,module.exports=a):"function"===typeof define&&define.amd?define("highcharts/modules/xrange",["highcharts"],function(h){a(h);a.Highcharts=h;return a}):a("undefined"!==typeof Highcharts?Highcharts:void 0)})(function(a){function h(a,b,v,d){a.hasOwnProperty(b)||(a[b]=d.apply(null,v),"function"===typeof CustomEvent&&window.dispatchEvent(new CustomEvent("HighchartsModuleLoaded",{detail:{path:b,module:a[b]}})))}a=a?a._modules:
{};h(a,"Series/XRange/XRangeSeriesDefaults.js",[a["Core/Utilities.js"]],function(a){var b=a.correctFloat,n=a.isNumber,d=a.isObject;"";return{colorByPoint:!0,dataLabels:{formatter:function(){var a=this.point.partialFill;d(a)&&(a=a.amount);if(n(a)&&0<a)return b(100*a)+"%"},inside:!0,verticalAlign:"middle"},tooltip:{headerFormat:'<span style="font-size: 0.8em">{point.x} - {point.x2}</span><br/>',pointFormat:'<span style="color:{point.color}">\u25cf</span> {series.name}: <b>{point.yCategory}</b><br/>'},
borderRadius:3,pointRange:0}});h(a,"Series/XRange/XRangePoint.js",[a["Core/Series/SeriesRegistry.js"],a["Core/Utilities.js"]],function(a,b){var n=this&&this.__extends||function(){var a=function(d,e){a=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(a,e){a.__proto__=e}||function(a,e){for(var d in e)Object.prototype.hasOwnProperty.call(e,d)&&(a[d]=e[d])};return a(d,e)};return function(d,e){function b(){this.constructor=d}if("function"!==typeof e&&null!==e)throw new TypeError("Class extends value "+
String(e)+" is not a constructor or null");a(d,e);d.prototype=null===e?Object.create(e):(b.prototype=e.prototype,new b)}}(),d=a.series.prototype.pointClass.prototype;b=b.extend;a=function(a){function b(){var e=null!==a&&a.apply(this,arguments)||this;e.options=void 0;e.series=void 0;return e}n(b,a);b.getColorByCategory=function(a,b){var e=a.options.colors||a.chart.options.colors;a=b.y%(e?e.length:a.chart.options.chart.colorCount);return{colorIndex:a,color:e&&e[a]}};b.prototype.resolveColor=function(){var a=
this.series;if(a.options.colorByPoint&&!this.options.color){var d=b.getColorByCategory(a,this);a.chart.styledMode||(this.color=d.color);this.options.colorIndex||(this.colorIndex=d.colorIndex)}else this.color||(this.color=a.color)};b.prototype.init=function(){d.init.apply(this,arguments);this.y||(this.y=0);return this};b.prototype.setState=function(){d.setState.apply(this,arguments);this.series.drawPoint(this,this.series.getAnimationVerb())};b.prototype.getLabelConfig=function(){var a=d.getLabelConfig.call(this),
b=this.series.yAxis.categories;a.x2=this.x2;a.yCategory=this.yCategory=b&&b[this.y];return a};b.prototype.isValid=function(){return"number"===typeof this.x&&"number"===typeof this.x2};return b}(a.seriesTypes.column.prototype.pointClass);b(a.prototype,{ttBelow:!1,tooltipDateKeys:["x","x2"]});"";return a});h(a,"Series/XRange/XRangeSeries.js",[a["Core/Globals.js"],a["Core/Color/Color.js"],a["Core/Series/SeriesRegistry.js"],a["Core/Utilities.js"],a["Series/XRange/XRangeSeriesDefaults.js"],a["Series/XRange/XRangePoint.js"]],
function(a,b,h,d,G,H){function e(){if(this.isXAxis){var a=x(this.dataMax,-Number.MAX_VALUE);for(var b=0,c=this.series;b<c.length;b++){var k=c[b];if(k.x2Data){var q=0;for(k=k.x2Data;q<k.length;q++){var A=k[q];if(A&&A>a){a=A;var f=!0}}}}f&&(this.dataMax=a)}}var n=this&&this.__extends||function(){var a=function(b,c){a=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(c,a){c.__proto__=a}||function(c,a){for(var k in a)Object.prototype.hasOwnProperty.call(a,k)&&(c[k]=a[k])};return a(b,c)};
return function(b,c){function k(){this.constructor=b}if("function"!==typeof c&&null!==c)throw new TypeError("Class extends value "+String(c)+" is not a constructor or null");a(b,c);b.prototype=null===c?Object.create(c):(k.prototype=c.prototype,new k)}}();a=a.noop;var C=b.parse,D=h.series.prototype,E=h.seriesTypes.column,v=d.addEvent,y=d.clamp,I=d.defined;b=d.extend;var F=d.find,w=d.isNumber,B=d.isObject,r=d.merge,x=d.pick,J=[],u=function(a){function b(){var c=null!==a&&a.apply(this,arguments)||this;
c.data=void 0;c.options=void 0;c.points=void 0;return c}n(b,a);b.compose=function(a){d.pushUnique(J,a)&&v(a,"afterGetSeriesExtremes",e)};b.prototype.init=function(){a.prototype.init.apply(this,arguments);this.options.stacking=void 0};b.prototype.getColumnMetrics=function(){var c=this,b=function(){for(var a=0,b=c.chart.series;a<b.length;a++){var k=b[a],q=k.xAxis;k.xAxis=k.yAxis;k.yAxis=q}};b();var q=a.prototype.getColumnMetrics.call(this);b();return q};b.prototype.cropData=function(a,b,q,d){b=D.cropData.call(this,
this.x2Data,b,q,d);b.xData=a.slice(b.start,b.end);return b};b.prototype.findPointIndex=function(a){var c=this.cropStart,b=this.points,d=a.id;if(d)var f=(f=F(b,function(a){return a.id===d}))?f.index:void 0;"undefined"===typeof f&&(f=(f=F(b,function(c){return c.x===a.x&&c.x2===a.x2&&!c.touched}))?f.index:void 0);this.cropped&&w(f)&&w(c)&&f>=c&&(f-=c);return f};b.prototype.alignDataLabel=function(c){var b=c.plotX;c.plotX=x(c.dlBox&&c.dlBox.centerX,c.plotX);a.prototype.alignDataLabel.apply(this,arguments);
c.plotX=b};b.prototype.translatePoint=function(a){var b=this.xAxis,c=this.yAxis,d=this.columnMetrics,f=this.options,e=f.borderRadius,h=f.minPointLength||0,l=(a.shapeArgs&&a.shapeArgs.width||0)/2,m=this.pointXOffset=d.offset,z=x(a.x2,a.x+(a.len||0)),t=a.plotX,g=b.translate(z,0,0,0,1);z=Math.abs(g-t);var p=this.chart.inverted,n=x(f.borderWidth,1)%2/2,v=d.offset,u=Math.round(d.width);h&&(h-=z,0>h&&(h=0),t-=h/2,g+=h/2);t=Math.max(t,-10);g=y(g,-10,b.len+10);I(a.options.pointWidth)&&(v-=(Math.ceil(a.options.pointWidth)-
u)/2,u=Math.ceil(a.options.pointWidth));f.pointPlacement&&w(a.plotY)&&c.categories&&(a.plotY=c.translate(a.y,0,1,0,1,f.pointPlacement));f=Math.floor(Math.min(t,g))+n;f={x:f,y:Math.floor(a.plotY+v)+n,width:Math.floor(Math.max(t,g))+n-f,height:u};a.shapeArgs=f;w(e)&&(a.shapeArgs.r=e);p?a.tooltipPos[1]+=m+l:a.tooltipPos[0]-=l+m-f.width/2;l=f.x;m=l+f.width;0>l||m>b.len?(l=y(l,0,b.len),m=y(m,0,b.len),g=m-l,a.dlBox=r(f,{x:l,width:m-l,centerX:g?g/2:null})):a.dlBox=null;l=a.tooltipPos;m=p?1:0;g=p?0:1;d=this.columnMetrics?
this.columnMetrics.offset:-d.width/2;l[m]=p?l[m]+f.width/2:y(l[m]+(b.reversed?-1:0)*f.width,0,b.len-1);l[g]=y(l[g]+(p?-1:1)*d,0,c.len-1);if(c=a.partialFill)B(c)&&(c=c.amount),w(c)||(c=0),w(e)&&(a.partShapeArgs=r(f,{r:e})),e=Math.max(Math.round(z*c+a.plotX-t),0),a.clipRectArgs={x:b.reversed?f.x+z-e:f.x,y:f.y,width:e,height:f.height}};b.prototype.translate=function(){a.prototype.translate.apply(this,arguments);for(var b=0,d=this.points;b<d.length;b++)this.translatePoint(d[b])};b.prototype.drawPoint=
function(a,b){var c=this.options,d=this.chart.renderer,f=a.shapeType,e=a.shapeArgs,k=a.partShapeArgs,l=a.clipRectArgs,m=a.state,h=c.states[m||"normal"]||{},n="undefined"===typeof m?"attr":b;m=this.pointAttribs(a,m);h=x(this.chart.options.chart.animation,h.animation);var g=a.graphic,p=a.partialFill;if(a.isNull||!1===a.visible)g&&(a.graphic=g.destroy());else{if(g)g.rect[b](e);else a.graphic=g=d.g("point").addClass(a.getClassName()).add(a.group||this.group),g.rect=d[f](r(e)).addClass(a.getClassName()).addClass("highcharts-partfill-original").add(g);
k&&(g.partRect?(g.partRect[b](r(k)),g.partialClipRect[b](r(l))):(g.partialClipRect=d.clipRect(l.x,l.y,l.width,l.height),g.partRect=d[f](k).addClass("highcharts-partfill-overlay").add(g).clip(g.partialClipRect)));this.chart.styledMode||(g.rect[b](m,h).shadow(c.shadow),k&&(B(p)||(p={}),B(c.partialFill)&&(p=r(c.partialFill,p)),a=p.fill||C(m.fill).brighten(-.3).get()||C(a.color||this.color).brighten(-.3).get(),m.fill=a,g.partRect[n](m,h).shadow(c.shadow)))}};b.prototype.drawPoints=function(){for(var a=
this.getAnimationVerb(),b=0,d=this.points;b<d.length;b++)this.drawPoint(d[b],a)};b.prototype.getAnimationVerb=function(){return this.chart.pointCount<(this.options.animationLimit||250)?"animate":"attr"};b.prototype.isPointInside=function(b){var c=b.shapeArgs,d=b.plotX,e=b.plotY;return c?"undefined"!==typeof d&&"undefined"!==typeof e&&0<=e&&e<=this.yAxis.len&&0<=(c.x||0)+(c.width||0)&&d<=this.xAxis.len:a.prototype.isPointInside.apply(this,arguments)};b.defaultOptions=r(E.defaultOptions,G);return b}(E);
b(u.prototype,{pointClass:H,cropShoulder:1,getExtremesFromAll:!0,parallelArrays:["x","x2","y"],requireSorting:!1,type:"xrange",animate:D.animate,autoIncrement:a,buildKDTree:a});h.registerSeriesType("xrange",u);return u});h(a,"masters/modules/xrange.src.js",[a["Core/Globals.js"],a["Series/XRange/XRangeSeries.js"]],function(a,b){b.compose(a.Axis)})});
//# sourceMappingURL=xrange.js.map